/*
**    3ETI Projet CPE Lyon
**    Copyright (C) 2011 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef _GLUT_HELPER_HPP_
#define _GLUT_HELPER_HPP_

#include <navigator_tool.hpp>

//init opengl and glut
void setup_opengl(int argc,char *argv[],const cpe::navigator_tool& navigator);
//keyboard callback
void keyboard_manager(unsigned char key,int x,int y,cpe::navigator_tool& navigator);
//mouse motion callback
void motion_manager(int x, int y,cpe::navigator_tool& navigator);
//mouse click callback
void mouse_manager(int button,int action,int x,int y,cpe::navigator_tool& nav);
//window reshape callback
void reshape_manager(int width,int height,cpe::navigator_tool& navigator);
//main display callback (begin)
void display_manager_begin(cpe::navigator_tool& navigator);
//main display callback (end)
void display_manager_end(cpe::navigator_tool& navigator,unsigned int& counter);

//draw central pointer
void draw_pointer(cpe::navigator_tool& navigator);
//printf fps on screen
void draw_fps(cpe::navigator_tool& navigator);
//draw orientation axes
void draw_orientation(cpe::navigator_tool& navigator);
//print some help at begining
void print_help_start();

#endif
